/***************************************************************************
* Circle.h                                                                 *
*                                                                          *
*   Changes:                                                               *
*                                                                          *
*       05/12/98    arvo    Broken out into a separate module.             *
*       07/09/96    arvo    Initial coding.                                *
*                                                                          *
***************************************************************************/
#ifndef __CIRCLE_INCLUDED__
#define __CIRCLE_INCLUDED__

#include "../util/Vec2.h" // 2-D vectors.

// 2-Dimensional Circle.

class Circle {

    public:
        Circle() { diameter = 0; }
        Circle( const Vec2 &cent, double rad ) { center = cent; diameter = 2 * rad; }
        Circle( const Circle &C ) { *this = C; }
       ~Circle() {}

    public:
        double  Diam   () const { return diameter; }
        double  Rad    () const { return diameter * 0.5; }
        double  Area   () const { return 0.25 * Pi * Sqr( diameter ); }
        double  Perim  () const { return Pi * diameter; }
        Vec2   Center () const { return center; }
        Vec2  &Center ()       { return center; }
        double  Width  () const { return diameter; }
        double  Height () const { return diameter; }
        Vec2   Closest( const Vec2 & ) const;
        int    Inside ( const Vec2 &, double tol = 0.0 ) const;
        void   Set( const Vec2 &P, double rad ) { center = P; diameter = 2.0 * rad; }

    public:
        static const Circle Null; // The default circle.

    private:
        Vec2  center;
        double diameter;
    };        


#endif














